varying vec2 tc0;

uniform sampler2D texture;

void main()
{

	vec4 col = texture2D(texture, tc0);

	//get focus point depth
	vec4 focus = texture2D(texture, vec2(0.5));

	//get calculate blur amount 
	float fac = (col.a-focus.a) * (col.a-focus.a);
	float blur = pow(fac, 0.25)*6.0-0.25;
	
	//blur parts which are out of focus
	col+= texture2D(texture, tc0+vec2( 0.0019 , 0.0)*blur);
	col+= texture2D(texture, tc0+vec2( 0.0019 , 0.0019)*blur);
	col+= texture2D(texture, tc0+vec2( 0.0    , 0.0019)*blur);
	col+= texture2D(texture, tc0+vec2(-0.0019 , 0.0)*blur);
	col+= texture2D(texture, tc0+vec2(-0.0019 , 0.0019)*blur);
	col+= texture2D(texture, tc0+vec2(-0.0019 ,-0.0019)*blur);
	col+= texture2D(texture, tc0+vec2(0.0     ,-0.0019)*blur);
	col+= texture2D(texture, tc0+vec2( 0.0019 ,-0.0019)*blur);
	col*= 0.1111;
	
	gl_FragColor =col;
}