
varying vec4 vtol; 
varying vec4 vtov; 
varying vec4 texcoords;
varying vec4 projCoords;
varying vec4 distance;

uniform vec4 lightPos;
uniform vec4 viewPos;


void main()
{

	texcoords = gl_MultiTexCoord0;

	vec3 tangent = gl_MultiTexCoord1.xyz;
	vec3 bitangent = gl_MultiTexCoord2.xyz;
	vec3 fnormal = gl_Normal;

	mat4 tbn = mat4(tangent, 0.0, 
					-bitangent, 0.0,
					fnormal, 0.0,
					vec4(0.0, 0.0, 0.0, 1.0));

	//calculate tangent space vector to light
	vec4 temp = lightPos - gl_Vertex;
	vtol = temp*tbn;
	vtol.w=0.0;

	//calculate tangent space vector to viewer position
	temp = viewPos - gl_Vertex;
	vtov = temp*tbn;
	vtov.w = 0.0;

	//projected texture coordinates
	projCoords = gl_TextureMatrix[2] * gl_Vertex;

	
	distance = gl_ModelViewProjectionMatrix * gl_Vertex;

	gl_Position = ftransform();

}