
varying vec4 vtol; 
varying vec4 vtov; 
varying vec4 texcoords;
varying vec4 projCoords;
varying float distance;

uniform vec4 lightPos;
uniform vec4 viewPos;


void main()
{

	texcoords = gl_MultiTexCoord0;

	vec3 tangent = gl_MultiTexCoord1.xyz;
	vec3 bitangent = gl_MultiTexCoord2.xyz;
	vec3 fnormal = gl_Normal;

	mat4 tbn = mat4(tangent, 0.0, 
					-bitangent, 0.0,
					fnormal, 0.0,
					vec4(0.0, 0.0, 0.0, 1.0));

	vec4 temp = lightPos - gl_Vertex;
	vtol = temp*tbn;

	temp = viewPos - gl_Vertex;
	vtov = temp*tbn;

	projCoords = gl_TextureMatrix[2] * gl_Vertex;

	distance = 1.0 - clamp(-gl_Vertex.y*32.0, 0.0, 1.0);

	gl_Position = ftransform();

}