
varying vec4 pos;
varying vec4 texcoords;

uniform sampler2D tex1;
uniform sampler2D tex2;
uniform float time;

void main()
{
	//load sky textures
	vec4 sky1 = texture2D(tex1, texcoords.xy);
	vec4 sky2 = texture2D(tex2, texcoords.xy);
	
	//clamp time
	float skyTime = clamp(time, 0.0, 1.0);

	//cross fade sky textures
	vec4 color = mix(sky1, sky2, skyTime);

	float depthInfo = pos.z/pos.w;

	gl_FragColor=vec4(color.xyz, depthInfo); //store depth in alpha channel
}